var startkaarten=10
var fs=require('fs')
var server=require('http').createServer((req,res)=>{
	if(req.url=='/') req.url='/index.html'
	if(req.url.includes('html')) res.writeHead(200,{'Content-Type': 'text/html'})
	try {
		res.end(fs.readFileSync('frontend'+req.url));
	} catch {
		res.end('file not found');
	}
})
server.listen(8080)
wslib=require('ws')
var ws=new wslib.Server({server})
var bot=require('./skipbobot.js')
console.log(typeof bot)
var games={}
var started=false
var kickInterval=null
function startInterval() {
	if(kickInterval) return
	console.log('starting interval')
	kickInterval=setInterval(function () {
		ws.clients.forEach(function(ws) {
			if(!ws.isAlive) {
				console.log('terminated connection')
				return ws.terminate();
			}
			ws.isAlive=false
			ws.ping(function () {})
		})
		if(ws.clients.size==0) {
			clearInterval(kickInterval)
			kickInterval=null
		}
		console.log('sending pings')
	},15*1000)
}
ws.on('connection', function (connection,request) {
	if(ws.clients.size==1) startInterval()
	var gameId=request.url.split('/').pop()
	if(!games[gameId]) games[gameId]=createGame(gameId)
	game=games[gameId]
	game.clients.push(connection)
	if(!game.started) {
		game.aantalSpelers++
		connection.playerId=game.aantalSpelers
	} else {
		connection.playerId=999
		connection.send(JSON.stringify(getSpelerInfo(connection.playerId)))
	}
	connection.gameId=gameId
	connection.isAlive=true
	connection.on('pong',function () {this.isAlive=true; console.log('pong received!')})
	connection.on('message',function (message) {
		game=games[gameId]
		game.deleteTimeout=removeTimeout(gameId)
		data=JSON.parse(message)
		if(receiveFromSpeler(connection,data.actie,data.data)) delete games[gameId]
		else games[gameId]=game
	})
	if(!game.started) sendToPlayers()
})
function removeGame(gameId) {
	game=games[gameId]
	endWithMessage('2 uur verstreken, game wordt gewist.')
	delete games[gameId]
}
function removeTimeout(gameId,first) {
	if(!first) clearTimeout(games[gameId].deleteTimeout)
	return setTimeout(function() {delete games[gameId]},2*60*60*1000)
	//todo
	//return setTimeout(function() {removeGame(gameId)},30000)
}
function createGame(gameId) {
	return {
		bots:[],
		started:false,
		recyclekaarten:[],
		kaarten:[],
		beurt:-5,
		aantalSpelers:-1,
		spelers:[],
		stapels:new Array(4).fill().map(function () {return {inhoud:[],top:0}}),
		clients:[],
		deleteTimeout:removeTimeout(gameId,true)
	}
}
function shuffleArray(array) {
	for (let i = array.length - 1; i > 0; i--) {
		const j = Math.floor(Math.random() * (i + 1));
		[array[i], array[j]] = [array[j], array[i]];
	}
}
function createkaarten() {
	game.kaarten=[]
	for(i=0;i<13;i++) {
		game.kaarten=game.kaarten.concat(new Array(12).fill(i))//12x 0-12
	}
	game.kaarten=game.kaarten.concat(new Array(6).fill(0))//6x skip erbij(totaal 18)
	shuffleArray(game.kaarten)
}
function grabkaarten(length) {
	var returned=[]
	for(i=0;i<length;i++) {
		if(game.kaarten.length==0) {
			if(game.recyclekaarten.length==0) endWithMessage('kaarten zijn op, spel wordt gesloten.')
			game.kaarten=game.recyclekaarten
			game.recyclekaarten=[]
			shuffleArray(game.kaarten)
		}
		returned.push(game.kaarten.pop())
	}
	return returned
}
function createSpelers(aantal,startkaarten=0) {
	createkaarten()
	if(aantal<5) kaartenaantal=30
	else kaartenaantal=20
	if(startkaarten) kaartenaantal=startkaarten
	game.spelers=Array(aantal).fill().map(function () {return {
		kaarten: grabkaarten(kaartenaantal),
		stapels: new Array(4).fill().map(function () {return []}),
		hand: [],
		geleend:false
	}})
	max=0
	game.spelers.forEach(function (speler) {
		if((speler.kaarten[0]||12)>max) max=(speler.kaarten[0]||12)
	})
	game.spelers.forEach(function(speler,spelerId) {
		if((speler.kaarten[0]||12)==max) game.beurt=spelerId
	})
	spelerBeurtStart(game.beurt)
}
function vulhand(spelerId) {
	hand=game.spelers[spelerId].hand
	game.spelers[spelerId].hand=hand.concat(grabkaarten(5-hand.length))
}
function spelerBeurtStart(spelerId) {
	vulhand(spelerId)
	game.spelers[spelerId].geleend=false
}
function getSpelerInfo(spelerId) {
	console.log(spelerId)
	speler=game.spelers[spelerId]
	if(game.started) {
		spelers=game.spelers.map(function (speler) {return {kaart:{top: speler.kaarten[0], aantal:speler.kaarten.length},stapels:speler.stapels.map(function (stapel) {return stapel[0]})}})
		stapels=game.stapels.map(function (stapel) {return stapel.top})
		if(!speler) {
			return {started:true,hand:[],geleend:[],eigenstapels:[],stapels:stapels,kaart:undefined,spelers:spelers,beurt:game.beurt,spelerId:spelerId,spelerAantal:game.aantalSpelers}
		} else {
			return {
				started:game.started,
				hand:speler.hand,
				geleend:speler.geleend,
				eigenstapels:speler.stapels.map(function (stapel) {return stapel[0]}),
				stapels:stapels,
				kaart:speler.kaarten[0],
				spelers:spelers,
				beurt:game.beurt,
				spelerId:spelerId,
				spelerAantal: game.aantalSpelers
			}
		}
	} else {
		return {
			started: game.started,
			spelerId:spelerId,
			spelerAantal:game.aantalSpelers+1
		}
	}
}
function sendToPlayers() {
	game.clients.forEach(function (client) {
		client.send(JSON.stringify(getSpelerInfo(client.playerId)))
	})
	console.log(game.bots)
	if(game.bots.indexOf(game.beurt)>-1) {
		bot(getSpelerInfo(game.beurt),function (actie,data) {
			receiveFromSpeler({playerId:game.beurt},actie,data)
		})
	}
}
function endWithMessage(message) {
	game.clients.forEach(function (client) {
		client.close(4321,message)
	})
}
function restart(message="") {
	endWithMessage('restarting!('+message+')')
	game.started=false
	game.recyclekaarten=[]
	game.kaarten=[]
	game.beurt=0
	game.aantalSpelers=-1
	game.spelers=[]
	game.stapels=new Array(4).fill().map(function () {return {inhoud:[],top:0}})
}
function kangeplaatst(kaart,stapelId) {
	mogelijk=false
	if(kaart==0) return true
	if(game.stapels[stapelId].top==(kaart-1)) return true
}
function plaatsen(kaart,stapelId) {
	game.stapels[stapelId].top++
	game.stapels[stapelId].inhoud.push(kaart)
}
function numb(number,max) {
//	return false
	console.log(number, typeof number,number>max,number<0)
	return ((typeof number!=='number')||number>max||number<0)
}
function receiveFromSpeler(connection,actie,arguments) {
	spelerId=connection.playerId
	if(actie=="start" && !game.started) {
		if(game.aantalSpelers==0) {
			game.aantalSpelers++
			game.bots.push(game.aantalSpelers)
		}
		createSpelers(game.aantalSpelers+1,arguments.kaarten)
		game.started=true
		sendToPlayers()
		return
	} else if(actie=="stop" && game.started) {
		if(spelerId>game.aantalSpelers) connection.close(4321,'geen speler.')
		else restart("game gestopt door speler "+spelerId+".")
	} else if(spelerId==game.beurt) {
		speler=game.spelers[spelerId]
		switch(actie) {
			case 'uithand':
				kaartId=arguments.kaartId
				if(numb(kaartId,4)) return
				stapelId=arguments.naarstapel
				if(numb(stapelId,3)) return
				console.log(JSON.stringify(speler,null,2))
				if(typeof speler.hand[kaartId]!=='number') return
				if(kangeplaatst(speler.hand[kaartId],stapelId)) {
					plaatsen(game.spelers[spelerId].hand[kaartId],stapelId)
					game.spelers[spelerId].hand.splice(kaartId, 1);
					if(speler.hand.filter(function (kaart) {if(kaart!==null) return true}).length==0) vulhand(spelerId)
				} else {
					console.log('kan niet geplaatst worden daar.')
				}
				break;
			case 'vanstapel':
				stapelId=arguments.naarstapel
				if(numb(stapelId,3)) return
				if(kangeplaatst(speler.kaarten[0],stapelId)) {
					kaart=game.spelers[spelerId].kaarten.shift()
					plaatsen(kaart,stapelId)
					if(speler.kaarten.length==0) {
						console.log('speler '+spelerId+' heeft gewonnen')
						sendToPlayers()
						endWithMessage('speler '+spelerId+' heeft gewonnen')
						restart()
					}
				} else {
					console.log('kan niet geplaatst worden daar.')
				}
				break;
			case 'lenen':
				if(speler.geleend) {
					console.log('al geleend')
				} else {
					vanspeler=arguments.vanSpeler
					if(numb(vanspeler,game.aantalSpelers)) return
					stapelId=arguments.stapelId
					if(numb(stapelId,4)) return
					naarstapel=arguments.naarStapelId
					if(numb(naarstapel,3)) return
					if(kangeplaatst(game.spelers[vanspeler].stapels[stapelId][0],naarstapel)) {
						kaart=game.spelers[vanspeler].stapels[stapelId].shift()
						plaatsen(kaart,naarstapel)
						game.spelers[spelerId].geleend=true
					} else {
						console.log('kan niet geplaatst worden daar')
					}
				}
				break;
			case 'wegleggen':
				kaartId=arguments.kaartId
				if(numb(kaartId,4)) return
				stapelId=arguments.naarstapel
				if(numb(stapelId,3)) return
				if(!speler.hand[kaartId]) return
				game.spelers[spelerId].stapels[stapelId].unshift(game.spelers[spelerId].hand[kaartId])
				game.spelers[spelerId].hand.splice(kaartId, 1);
				game.beurt++
				if(game.beurt>game.aantalSpelers) game.beurt=0
				spelerBeurtStart(game.beurt)
				break;
		}
		game.stapels.forEach(function (stapel,stapelId) {
			if(stapel.top==12) {
				game.recyclekaarten=game.recyclekaarten.concat(stapel.inhoud)
				game.stapels[stapelId]={inhoud:[],top:0}
			}
		})
		sendToPlayers()
	} else {
		console.log("niet aan de beurt")
	}
}
console.log('started!')
